#ifndef GSLOOP_TYPES_H
#define GSLOOP_TYPES_H

#include <rn.h>

#include <libgsloop.h>
#include <gsloop_misc.h>

struct gsloop;
union gsloop_con;

typedef int	(*gsloop_close_fn_t)		(struct gsloop		*gsloop,
						 union gsloop_con	*gsloop_con);

struct gsloop {
	rn_t				rn;

	struct gsloop_attr		attr;

	union gsloop_con		*con_list;
	int				con_alloced;
	int				con_used;
};


#define GSLOOP_CON_COMMON				\
	void				*data;		\
	int				fd;		\
	gsloop_close_fn_t		close


struct gsloop_server {
	GSLOOP_CON_COMMON;

	gsloop_server_add_fn_t		client_added;		/* is called when client is added to server */

	gsloop_close_fn_t		client_close;		/* client's close funktion */
	gsloop_client_cb_fn_t		client_cb;		/* client's function, called when client is ready */
	void				*client_data;		/* arg passed to client callback fn */

	struct gsloop_server_attr	attr;
};

struct gsloop_client {
	GSLOOP_CON_COMMON;
	gsloop_client_cb_fn_t		cb;			/* client's function, called when client is ready */
};

struct gsloop_common {
	GSLOOP_CON_COMMON;
};

union gsloop_con {
	struct gsloop_server		server;
	struct gsloop_client		client;
	struct gsloop_common		common;
};


#endif	/* !GSLOOP_TYPES_H */
