#include <assert.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>

#include <gsloop_types.h>


int gsloop_con_init(struct gsloop	*gsloop)
{
	gsloop->con_used = 0;
	gsloop->con_alloced = 16;

	gsloop->con_list = (union gsloop_con *)calloc(gsloop->con_alloced, sizeof(union gsloop_con));
	if (!gsloop->con_list)
		return -ENOMEM;
	
	return 0;
}


int gsloop_con_destroy(struct gsloop	*gsloop)
{
	free(gsloop->con_list);

	return 0;
}


union gsloop_con *gsloop_con_alloc_and_add(struct gsloop	*gsloop,
					   int			fd)
{
	int	con_alloced = gsloop->con_alloced;
	int	n;

	if (fd >= con_alloced) {
		union gsloop_con	*con_list_new;

		if (fd >= con_alloced * 2) {
			return NULL;
		}

		n = con_alloced * 2;

		con_list_new = (union gsloop_con *)realloc(gsloop->con_list, n * sizeof(union gsloop_con));
		if (!con_list_new) {
			return NULL;
		}
		memset(gsloop->con_list + con_alloced, 0, n - con_alloced);

		gsloop->con_list = con_list_new;
		gsloop->con_alloced = con_alloced = n;
	}

	assert(fd < con_alloced);

	return gsloop->con_list + fd;
}


struct gsloop_client
*gsloop_con_get_client(struct gsloop	*gsloop,
		       int		fd)
{
	return &gsloop->con_list[fd].client;
}


struct gsloop_server
*gsloop_con_get_server(struct gsloop	*gsloop,
		       int		fd)
{
	return &gsloop->con_list[fd].server;
}
